<?php
/**
 * DZF
 *
 * LICENSE: Redistribution and use in source and binary forms, with or without
 * modifications, are not permitted.
 *
 * @copyright Deubert IT-Solutions © 2012-2014 All rights reserved
 * @package DZF
 */

#namespace DeubertIt;

/**
 * @author Rostislav Boiko <r.boyko@luckywarepro.com>
 */
class DZF_AuditLog_Listener extends \Doctrine_AuditLog_Listener {

    public function preUpdate(\Doctrine_Event $event) {
        if ($this->_auditLog->getOption('auditLog')) {
            $record = $event->getInvoker();

            $version = $this->_auditLog->getOption('version');
            $name = $version['alias'] === null ? $version['name'] : $version['alias'];
            $names = array($name, "updated_at");
            $affected_keys = array_keys($record->getModified());
            $trigger = false;
            foreach ($affected_keys as $key) {
                if (!in_array($key, $names)
                        && (strpos($key, "flat_") !== 0)) {//prevent trigger from flat fields
                    $trigger = true;
                    break;
                }
            }
            if ($trigger) {
                parent::preUpdate($event);
            }
        }
    }

}
