<?php
/**
 * DZF
 *
 * LICENSE: Redistribution and use in source and binary forms, with or without
 * modifications, are not permitted.
 *
 * @copyright Deubert IT-Solutions © 2012-2014 All rights reserved
 * @package DZF
 */

#namespace DeubertIt;

/**
 * @author Karsten Deubert <info@deubert.it>
 */
class DZF_Controller_Plugin_Annotation_Layout extends DZF_Controller_Plugin_Annotation_Abstract
{
    /**
     * @param \Zend_Controller_Request_Abstract $request
     * @return void
     */
    public function preDispatch(\Zend_Controller_Request_Abstract $request)
    {
        /** @var $request \Zend_Controller_Request_Http */
        if (!$request instanceof \Zend_Controller_Request_Http)
        {
            return;
        }

        /** @var $zfDebugTimePlugin \ZFDebug_Controller_Plugin_Debug_Plugin_Time */
        $zfDebugTimePlugin = \Zend_Controller_Front::getInstance()->getPlugin('ZFDebug_Controller_Plugin_Debug_Plugin_Time');
        if ($zfDebugTimePlugin && is_object($zfDebugTimePlugin))
        {
            $zfDebugTimePlugin->mark('annotation_layout start');
        }

        $docBlock = $this->_getDocblockForControllerAction();

        $pattern = '#@layout (\S+)#iu';

        $matches = array();
        $matchesCount = preg_match($pattern, $docBlock, $matches);

        if (!$matchesCount)
        {
            if ($zfDebugTimePlugin && is_object($zfDebugTimePlugin))
            {
                $zfDebugTimePlugin->mark('annotation_layout stop (no match)');
            }
            return;
        }

        $layout = \Zend_Layout::getMvcInstance();

        if ($matches[1] === 'disabled')
        {
            $layout->disableLayout();
        }
        else
        {
            $layout->setLayout($matches[1]);
        }

        if ($zfDebugTimePlugin && is_object($zfDebugTimePlugin))
        {
            $zfDebugTimePlugin->mark('annotation_layout stop (match)');
        }
    }
}