<?php
/**
 * DZF
 *
 * LICENSE: Redistribution and use in source and binary forms, with or without
 * modifications, are not permitted.
 *
 * @copyright Deubert IT-Solutions © 2017 All rights reserved
 * @package DZF
 */

#namespace DeubertIt;

/**
 * @author Eugene Melnik <e.melnik@luckywarepro.com>
 */
class DZF_Settings_Source_Doctrine_Migration extends \Doctrine_Migration_Base
{
    private $_tableName = DZF_Settings_Source_Doctrine_Model::SETTINGS_TABLE_NAME;

    public final function up()
    {
        $this->createTable($this->_tableName, array(
            'id' => array(
                'type'      => 'integer',
                'unsigned'  => true,
                'notnull'   => true,
                'primary'   => true,
                'autoincrement' => true,
                'length'    => 10
            ),
            'group_key' => array(
                'type'      => 'string',
                'length'    => 255
            ),
            'param_key' => array(
                'type'      => 'string',
                'length'    => 255
            ),
            'value' => array(
                'type'      => 'text'
            )
        ));

        $this->addIndex($this->_tableName, 'section_parameter', array(
            'fields' => array('group_key', 'param_key')
        ));
    }

    public final function down()
    {
        $this->dropTable($this->_tableName);
    }
}
