<?php
/**
 * DZF
 *
 * LICENSE: Redistribution and use in source and binary forms, with or without
 * modifications, are not permitted.
 *
 * @copyright Deubert IT-Solutions © 2017 All rights reserved
 * @package DZF
 */

#namespace DeubertIt;

/**
 * @author Eugene Melnik <e.melnik@luckywarepro.com>
 */
class DZF_Settings_Source_Doctrine_Model extends \Doctrine_Record
{
    const SETTINGS_TABLE_NAME = 'dzf_settings';

    public function setTableDefinition()
    {
        $this->setTableName(self::SETTINGS_TABLE_NAME);

        $this->hasColumn('id', 'integer', 10, array(
            'type'      => 'integer',
            'unsigned'  => true,
            'notnull'   => true,
            'primary'   => true,
            'autoincrement' => true
        ));

        $this->hasColumn('group_key', 'string', 255);

        $this->hasColumn('param_key', 'string', 255);

        $this->hasColumn('value', 'text');

        $this->index('section_parameter', array('fields' => 'group_key', 'param_key'));
    }
}
