<?php

class DZF_Controller_Request_HttpTests extends DZF_Helpers_TestCaseBase
{
    public function testSetServer()
    {
        $expectedValue = 'testValue';

        $uri = 'http://test.example.com/';
        $http = new DZF_Controller_Request_Http($uri);
        $http->setServer('testsKey', $expectedValue);

        $this->assertEquals($expectedValue, $http->getServer('testsKey'));
    }

    public function testGetServer()
    {
        $expectedValue = 'testValue';

        $uri = 'http://test.example.com/';
        $http = new DZF_Controller_Request_Http($uri);
        $http->setServer('testsKey', $expectedValue);

        $result = $http->getServer('testsKey');
        $this->assertEquals($expectedValue, $result);
    }

    public function testSetQuery()
    {
        $expectedValue = 'testValue';

        $uri = 'http://test.example.com/';
        $http = new DZF_Controller_Request_Http($uri);
        $result = $http->setQuery('testsKey', $expectedValue);

        $this->assertNotNull($result);
    }

    public function testGetQuery()
    {
        $expectedValue = 'testValue';

        $uri = 'http://test.example.com/';
        $http = new DZF_Controller_Request_Http($uri);
        $http->setQuery('testsKey', $expectedValue);

        $this->assertEquals($expectedValue, $http->getQuery('testsKey'));
    }

    public function testBuildUrlException()
    {
        $expectedUri = 'http://test.com/';

        $request = new RequestTest();
        $request->setRequestUri('test.com/');
        $url = DZF_Controller_Request_Http::buildUrl($request);

        $this->assertEquals($expectedUri, $url);
    }
}
