<?php

class DZF_Controller_Router_Route_TrailingSlashTests extends DZF_Helpers_TestCaseBase
{
    public function testGetInstance()
    {
        $options = array(
            'plugins' => array('Variables',
                'File' => array('basePath' => '/path/to/project'),
                'Cache' => array('backend' => ['a' => 1]),
            )
        );

        $zendConfig = new Zend_Config($options);

        $trailingSlash = DZF_Controller_Router_Route_TrailingSlash::getInstance($zendConfig);

        $this->assertNotNull($trailingSlash);
    }

    public function testAssemble()
    {
        $expectedUrl = 'https://new.test.com/';

        $options = array(
            'plugins' => array('Variables',
                'File' => array('basePath' => '/path/to/project'),
                'Cache' => array('backend' => ['a' => 1]),
            )
        );

        $trailingSlash = new DZF_Controller_Router_Route_TrailingSlash($expectedUrl);
        $result = $trailingSlash->assemble($options);

        $this->assertEquals($expectedUrl, $result);
    }

    public function testAssembleSlash()
    {
        $expectedUrl = 'https://new.test.com/';

        $options = array(
            'plugins' => array('Variables',
                'File' => array('basePath' => '/path/to/project'),
                'Cache' => array('backend' => ['a' => 1]),
            )
        );

        $trailingSlash = new DZF_Controller_Router_Route_TrailingSlash('https://new.test.com');
        $result = $trailingSlash->assemble($options);

        $this->assertEquals($expectedUrl, $result);
    }
}
