<?php

class DZF_Form_Decorator_ErrorsTests extends DZF_Helpers_TestCaseBase
{
    public function testRender()
    {
        $expectedContent = 'Test content';

        $formErrors = new DZF_Form_Decorator_Errors();
        $element = new Zend_Form_Element('Elem');
        $formErrors->setElement($element);

        $result = $formErrors->render($expectedContent);

        $this->assertEquals($expectedContent, $result);
    }

    public function testRenderWithoutError()
    {
        $expectedContent = 'Test content';

        $formErrors = new DZF_Form_Decorator_Errors();
        $view = new ViewInterfaceTest();
        $element = new Zend_Form_Element('Elem');
        $element->setView($view);
        $formErrors->setElement($element);

        $result = $formErrors->render($expectedContent);

        $this->assertEquals($expectedContent, $result);
    }

    public function testRenderErrorsAppend()
    {
        $expectedContent = 'Test content
errors';

        $formErrors = new DZF_Form_Decorator_Errors();
        $view = new ViewInterfaceTest();
        $element = new FormElementTest('Elem');
        $element->setView($view);
        $element->setMessage();
        $formErrors->setElement($element);

        $result = $formErrors->render('Test content');

        $this->assertEquals($expectedContent, $result);
    }

    public function testRenderErrorsPrepend()
    {
        $expectedContent = 'errors
Test content';

        $formErrors = new FormDecoratorErrorsTest();
        $view = new ViewInterfaceTest();
        $element = new FormElementTest('Elem');
        $element->setView($view);
        $element->setMessage();
        $formErrors->setElement($element);
        $formErrors->setPlacement(FormDecoratorErrorsTest::PREPEND);

        $result = $formErrors->render('Test content');

        $this->assertEquals($expectedContent, $result);
    }

    public function testNotRender()
    {
        $expectedContent = 'errors
Test content';

        $formErrors = new FormDecoratorErrorsTest();
        $view = new ViewInterfaceTest();
        $element = new FormElementTest('Elem');
        $element->setView($view);
        $element->setMessage();
        $formErrors->setElement($element);
        $formErrors->setPlacement('TEST');

        $formErrors->render('Test content');
    }
}
