<?php


class DZF_InflectorTests extends DZF_Helpers_TestCaseBase
{
    public function testUrlize()
    {
        $text = "This test text has a random characters like 'Ä', 'Ü', 'Ö', 'ä', 'ü','ö' or 'ß'";
        $expectedText = 'this-test-text-has-a-random-characters-like-ae-ue-oe-ae-ue-oe-or-ss';

        $urlizeTest = DZF_Inflector::urlize($text);

        $this->assertEquals($expectedText, $urlizeTest);
    }

    public function testUrlizeNotUtf8()
    {
        $text = 'this-test-text-has-a-random-characters-like üüüü';
        $expectedText = 't-h-i-s-t-e-s-t-t-e-x-t-h-a-s-a-r-a-n-d-o-m-c-h-a-r-a-c-t-e-r-s-l-i-k-e-ue-ue-ue-ue';

        $html_utf8 = mb_convert_encoding($text, 'byte2be', 'utf-8');

        $urlizeTest = DZF_Inflector::urlize($html_utf8);

        $this->assertEquals($expectedText, $urlizeTest);
    }
}
