<?php

class DZF_Log_Writer_Doctrine_ModelTests extends DZF_Helpers_TestCaseBase
{
    /**
     * @expectedException DZF_Exception
     * @expectedExceptionMessage Deleting of the log records is prohibited!
     */
    public function testDelete()
    {
        $doctrineModel = new DZF_Log_Writer_Doctrine_Model();

        $doctrineModel->delete(self::$connection);
    }

    public function testGetPriorityStringMapping()
    {
        $expectedMapping = array(
            \Zend_Log::EMERG => 'Emergency',
            \Zend_Log::ALERT => 'Alert',
            \Zend_Log::CRIT  => 'Critical',
            \Zend_Log::ERR   => 'Error',
            \Zend_Log::WARN  => 'Warning',
            \Zend_Log::NOTICE => 'Notice',
            \Zend_Log::INFO  => 'Informational',
            \Zend_Log::DEBUG => 'Debug'
        );

        $doctrineModelMapping = DZF_Log_Writer_Doctrine_Model::getPriorityStringMapping();

        $this->assertEquals($expectedMapping, $doctrineModelMapping);
    }

    public function testGetPriorityString()
    {
        $doctrineModel = new DZF_Log_Writer_Doctrine_Model();

        $priorityString = $doctrineModel->getPriorityString();

        $this->assertEquals('', $priorityString);
    }

    public function testGetPriorityLabelClass()
    {
        $doctrineModel = new DZF_Log_Writer_Doctrine_Model();

        $priorityLabel = $doctrineModel->getPriorityLabelClass();

        $this->assertEquals('', $priorityLabel);
    }

    public function testGetToArray()
    {
        $expectedArray = array(
            'id' => null,
            'timestamp' => null,
            'priority' => null,
            'namespace' => null,
            'message' => null,
            'priority_string' => null,
            'priority_label_class' => null
        );

        $doctrineModel = new DZF_Log_Writer_Doctrine_Model();

        $priorityArray = $doctrineModel->toArray();

        $this->assertEquals($expectedArray, $priorityArray);
    }
}
