<?php

class DZF_Nagios_PluginTests extends DZF_Helpers_TestCaseBase
{
    public function testGetResult()
    {
        $plugin = new PluginTest();

        $expectedText = 'new status - new message
';
        $result = $plugin->getResult($result);

        $this->assertEquals($expectedText, $result);
    }

    /**
     * @expectedException Exception
     * @expectedExceptionMessage Formatter should be the instance of DZF_Nagios_Formatter class or the string.
     */
    public function testSetFormatterException()
    {
        $plugin = new PluginTest();
        $formatter = new TestView();

        $plugin->setFormatter($formatter);
    }

    public function testSetFormatter()
    {
        $plugin = new PluginTest();
        $formatter = new DZF_Nagios_Formatter_LongText();

        $result = $plugin->setFormatter($formatter);

        $this->assertNotNull($result);
    }

    public function testGetFormatter()
    {
        $plugin = new PluginTest();

        $result = $plugin->getFormatter();

        $this->assertNotNull($result);
    }

    public function testSetWarning()
    {
        $plugin = new PluginTest();

        $expectedText = 'Test warning';
        $result = $plugin->setWarning($expectedText);

        $this->assertNotNull($result);
        $this->assertEquals($expectedText, $result->getWarning());
    }

    public function testGetWarning()
    {
        $plugin = new PluginTest();

        $expectedText = 'Test warning';
        $plugin->setWarning($expectedText);
        $result = $plugin->getWarning();

        $this->assertNotNull($result);
        $this->assertEquals($expectedText, $result);
    }

    public function testSetCritical()
    {
        $plugin = new PluginTest();

        $expectedText = 'Test critical';
        $result = $plugin->setCritical($expectedText);

        $this->assertNotNull($result);
        $this->assertEquals($expectedText, $result->getCritical());
    }

    public function testGetCritical()
    {
        $plugin = new PluginTest();

        $expectedText = 'Test critical';
        $plugin->setCritical($expectedText);
        $result = $plugin->getCritical();

        $this->assertNotNull($result);
        $this->assertEquals($expectedText, $result);
    }

    public function testSetMax()
    {
        $plugin = new PluginTest();

        $expectedMax = 10000;
        $result = $plugin->setMax($expectedMax);

        $this->assertNotNull($result);
        $this->assertEquals($expectedMax, $result->getMax());
    }

    public function testGetMax()
    {
        $plugin = new PluginTest();

        $expectedMax = 10000;
        $plugin->setMax($expectedMax);
        $result = $plugin->getMax();

        $this->assertNotNull($result);
        $this->assertEquals($expectedMax, $result);
    }

    public function testSetMin()
    {
        $plugin = new PluginTest();

        $expectedMin = -10000;
        $result = $plugin->setMin($expectedMin);

        $this->assertNotNull($result);
        $this->assertEquals($expectedMin, $result->getMin());
    }

    public function testGetMin()
    {
        $plugin = new PluginTest();

        $expectedMin = -10000;
        $plugin->setMin($expectedMin);
        $result = $plugin->getMin();

        $this->assertNotNull($result);
        $this->assertEquals($expectedMin, $result);
    }

    public function testGetVersion()
    {
        $expectedVersion = '1.0.0';
        $pluginVersion = DZF_Nagios_Plugin::getVersion();

        $this->assertEquals($expectedVersion, $pluginVersion);
    }

    public function testGetVersionMajor()
    {
        $expectedVersion = '1';
        $pluginVersion = DZF_Nagios_Plugin::getVersion('major');

        $this->assertEquals($expectedVersion, $pluginVersion);
    }

    public function testGetVersionMinor()
    {
        $expectedVersion = '0';
        $pluginVersion = DZF_Nagios_Plugin::getVersion('minor');

        $this->assertEquals($expectedVersion, $pluginVersion);
    }

    public function testGetVersionFix()
    {
        $expectedVersion = '0';
        $pluginVersion = DZF_Nagios_Plugin::getVersion('minor');

        $this->assertEquals($expectedVersion, $pluginVersion);
    }
}
