<?php

class DZF_View_Helper_FlashMessengerTests extends DZF_Helpers_TestCaseBase
{
    public function testSetType()
    {
        $flashMessenger = new DZF_View_Helper_FlashMessenger();

        $messenger = $flashMessenger->setType(DZF_View_Helper_FlashMessenger::TYPE_INFO);

        $this->assertNotNull($messenger);
    }

    /**
     * @expectedException Zend_View_Exception
     * @expectedExceptionMessage Message type 'type' does not exist
     */
    public function testSetTypeException()
    {
        $flashMessenger = new DZF_View_Helper_FlashMessenger();

        $flashMessenger->setType('type');
    }

    public function testSetClass()
    {
        $class = 'TestClass';

        $flashMessenger = new DZF_View_Helper_FlashMessenger();

        $messenger = $flashMessenger->setClass($class);

        $this->assertNotNull($messenger);
    }

    public function testSetDefaultType()
    {
        $flashMessenger = new DZF_View_Helper_FlashMessenger();

        $messenger = $flashMessenger->setDefaultType(DZF_View_Helper_FlashMessenger::TYPE_SUCCESS);

        $this->assertNotNull($messenger);
    }

    /**
     * @expectedException Zend_View_Exception
     * @expectedExceptionMessage Message type 'type' does not exist
     */
    public function testSetDefaultTypeException()
    {
        $flashMessenger = new DZF_View_Helper_FlashMessenger();

        $flashMessenger->setDefaultType('type');
    }

    public function testToString()
    {
        $flashMessenger = new DZF_View_Helper_FlashMessenger();

        $messenger = $flashMessenger->toString();

        $this->assertNotNull($messenger);
    }

    public function test__ToString()
    {
        $flashMessenger = new DZF_View_Helper_FlashMessenger();

        $messenger = $flashMessenger->__toString();

        $this->assertNotNull($messenger);
    }

    public function test__callException()
    {
        $flashMessenger = new FlashMessengerTest();

        $messenger = $flashMessenger->__call('setTestMessageClass', ['args1']);

        $this->assertNotNull($messenger);
    }

    public function testToStringInArray()
    {
        $expectedHtml = '<div class="flashMessenger"><ul><li>escape</li><li>escape</li><li>escape</li></ul><ul><li>escape</li><li>escape</li><li>escape</li></ul></div>';
        $view = new ViewInterfaceTest();

        $flashMessenger = new FlashMessengerTest();
        $flashMessenger->setView($view);

        $html = $flashMessenger->toString();

        $this->assertEquals($expectedHtml, $html);
    }
}
