<?php


class FormatExternalLinkTests extends DZF_Helpers_TestCaseBase
{
    public function testExternalLinkHtmlspecialchars()
    {
        $testUrl = 'www.test&&&.com';
        $expectedUrl = '<a href="www.test&&&.com" class="link-external" target="_blank" rel="nofollow">www.test&amp;&amp;&amp;.com</a>';

        $form = new TestView();
        $externalLink = new DZF_View_Helper_FormatExternalLink();
        $externalLink->setView($form);
        $link = $externalLink->formatExternalLink($testUrl);

        $this->assertEquals($expectedUrl, $link);
    }

    public function testExternalLinkStripTags()
    {
        $testUrl = 'www.test&&&<php|?>.com';
        $expectedUrl = '<a href="www.test&&&<php|?>.com" class="link-external" target="_blank" rel="nofollow">www.test&&&.com</a>';

        $form = new TestView();
        $form->setEscape('strip_tags');
        $externalLink = new DZF_View_Helper_FormatExternalLink();
        $externalLink->setView($form);
        $link = $externalLink->formatExternalLink($testUrl);

        $this->assertEquals($expectedUrl, $link);
    }
}
