<?php

class FormatFilesizeTests extends DZF_Helpers_TestCaseBase
{
    public function testFormatFilesizeZero()
    {
        $bytes = 0;
        $expectedBytes = '0 bytes';

        $form = new TestView();
        $formatFilesize = new DZF_View_Helper_FormatFilesize();
        $formatFilesize->setView($form);
        $format = $formatFilesize->formatFilesize($bytes);

        $this->assertEquals($expectedBytes, $format);
    }

    public function testFormatFilesizeOne()
    {
        $bytes = 1;
        $expectedBytes = '1 byte';

        $form = new TestView();
        $formatFilesize = new DZF_View_Helper_FormatFilesize();
        $formatFilesize->setView($form);
        $format = $formatFilesize->formatFilesize($bytes);

        $this->assertEquals($expectedBytes, $format);
    }

    public function testFormatFilesize1024()
    {
        $bytes = 1024;
        $expectedBytes = '1.00 KB';

        $form = new TestView();
        $formatFilesize = new DZF_View_Helper_FormatFilesize();
        $formatFilesize->setView($form);
        $format = $formatFilesize->formatFilesize($bytes);

        $this->assertEquals($expectedBytes, $format);
    }

    public function testFormatFilesize1048576()
    {
        $bytes = 1048576;
        $expectedBytes = '1.00 MB';

        $form = new TestView();
        $formatFilesize = new DZF_View_Helper_FormatFilesize();
        $formatFilesize->setView($form);
        $format = $formatFilesize->formatFilesize($bytes);

        $this->assertEquals($expectedBytes, $format);
    }

    public function testFormatFilesize1073741824()
    {
        $bytes = 1073741824;
        $expectedBytes = '1.00 GB';

        $form = new TestView();
        $formatFilesize = new DZF_View_Helper_FormatFilesize();
        $formatFilesize->setView($form);
        $format = $formatFilesize->formatFilesize($bytes);

        $this->assertEquals($expectedBytes, $format);
    }
}
