<?php

class DZF_View_Helper_NavigationTests extends DZF_Helpers_TestCaseBase
{
    public function testFindHelper()
    {
        $view = new ViewInterfaceTest();

        $navigation = new DZF_View_Helper_Navigation();
        $navigation->setView($view);

        $helper = $navigation->findHelper('testProxy');

        $this->assertNotNull($helper);
    }

    public function testFindHelperStrictFalse()
    {
        $view = new ViewInterfaceTest();

        $navigation = new DZF_View_Helper_Navigation();
        $navigation->setView($view);

        $helper = $navigation->findHelper('testProxy', false);

        $this->assertNotNull($helper);
    }

    public function testFindHelperException()
    {
        $view = new ViewInterfaceExceptionTest();

        $navigation = new DZF_View_Helper_Navigation();
        $navigation->setView($view);

        $helper = $navigation->findHelper('testProxy', false);

        $this->assertNull($helper);
    }

    public function testFindHelperExceptionView()
    {
        $view = new ViewInterfaceExceptionViewTest();

        $navigation = new DZF_View_Helper_Navigation();
        $navigation->setView($view);

        $helper = $navigation->findHelper('testProxy', false);

        $this->assertNull($helper);
    }
}
